PTHREAD_COND_WAIT(3)

NAME
pthread_cond_wait - wait on a condition variable

LIBRARY
libpthread

SYNOPSIS
#include <pthread.h>
int
pthread_cond_wait(pthread_cond_t *cond, pthread_mutex_t *mutex);

DESCRIPTION
The pthread_cond_wait() function atomically blocks the current thread waiting on the condition variable specified by cond, and releases the mutex specified by mutex. The waiting thread unblocks only after another thread calls pthread_cond_signal(3), or pthread_cond_broadcast(3) with the same condition variable, and the current thread reacquires the lock on mutex.

RETURN VALUES
If successful, the pthread_cond_wait() function will return zero. Otherwise an error number will be returned to indicate the error.

ERRORS
The pthread_cond_wait() function will fail if:

[EINVAL]
    The value specified by cond or the value specified by mutex is invalid.

[EPERM]
    The specified mutex was not locked by the calling thread.

SEE ALSO
pthread_cond_broadcast(3), pthread_cond_destroy(3), pthread_cond_init(3), pthread_cond_signal(3), pthread_cond_timedwait(3)

STANDARDS
The pthread_cond_wait() function conforms to p1003.1-96.